ORIGIN = PWB
ORIGIN_VER = 2.0
PROJ = retune
PROJFILE = msretune.mak
DEBUG = 0

CC  = cl
CFLAGS_G  = /AL /W2 /I../../LIB /BATCH
CFLAGS_D  = /f /Od /Zi
CFLAGS_R  = /f- /Ot /Ol /Og /Oe /Oi /Gs
CXX  = cl
CXXFLAGS_G  = /W2 /BATCH
CXXFLAGS_D  = /f /Zi /Od
CXXFLAGS_R  = /f- /Ot /Oi /Ol /Oe /Og /Gs
MAPFILE_D  = NUL
MAPFILE_R  = NUL
LFLAGS_G  = /NOI /BATCH /ONERROR:NOEXE
LFLAGS_D  = /CO /FAR /PACKC
LFLAGS_R  = /EXE /FAR /PACKC
LINKER	= link
ILINK  = ilink
LRF  = echo > NUL
ILFLAGS  = /a /e
RUNFLAGS  = -tune map.tun

FILES  = RETUNE.C ..\..\LIB\CMTLIB.LIB
OBJS  = RETUNE.obj
LIBS_EXT  = ..\..\LIB\CMTLIB.LIB
LIBS  = $(LIBS_EXT)

all: $(PROJ).exe

.SUFFIXES:
.SUFFIXES:
.SUFFIXES: .obj .c

RETUNE.obj : RETUNE.C ..\..\LIB\musiprog.h ..\..\LIB\midicode.h\
	..\..\LIB\cext.h ..\..\LIB\midifns.h C:\C700\INCLUDE\stdio.h\
	..\..\LIB\userio.h ..\..\LIB\timebase.h ..\..\LIB\moxc.h\
	..\..\LIB\switches.h C:\C700\INCLUDE\stdlib.h\
	C:\C700\INCLUDE\sys\types.h C:\C700\INCLUDE\stddef.h ..\..\LIB\mem.h\
	..\..\LIB\cleanup.h ..\..\LIB\swlogic.h
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoRETUNE.obj RETUNE.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoRETUNE.obj RETUNE.C
<<
!ENDIF


$(PROJ).exe : $(OBJS) $(LIBS)
!IF $(DEBUG)
	$(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_D)
$(LIBS: = +^
) +
$(LLIBS_G: = +^
) +
$(LLIBS_D: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_D);
<<
!ELSE
	$(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_R)
$(LIBS: = +^
) +
$(LLIBS_G: = +^
) +
$(LLIBS_R: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_R);
<<
!ENDIF
	$(LINKER) @$(PROJ).lrf


.c.obj :
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /Fo$@ $<
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /Fo$@ $<
<<
!ENDIF


run: $(PROJ).exe
	$(PROJ).exe $(RUNFLAGS)

debug: $(PROJ).exe
	CV $(CVFLAGS) $(PROJ).exe $(RUNFLAGS)
