ORIGIN = PWB
ORIGIN_VER = 2.0
PROJ = CMTLIB
PROJFILE = MSCMTLIB.MAK
DEBUG = 0

BSCMAKE  = bscmake
SBRPACK  = sbrpack
NMAKEBSC1  = set
NMAKEBSC2  = nmake
CC  = cl
CFLAGS_G  = /AL /W2 /BATCH
CFLAGS_D  = /f /Zi /Od
CFLAGS_R  = /f- /Ot /Oi /Ol /Oe /Og /Gs
CXX  = cl
CXXFLAGS_G  = /W2 /BATCH
CXXFLAGS_D  = /f /Zi /Od
CXXFLAGS_R  = /f- /Ot /Oi /Ol /Oe /Og /Gs
MAPFILE_D  = NUL
MAPFILE_R  = NUL
LFLAGS_G  = /NOI /BATCH /ONERROR:NOEXE
LFLAGS_D  = /CO /FAR /PACKC
LFLAGS_R  = /EXE /FAR /PACKC
LINKER	= link
ILINK  = ilink
LIB = lib
LRF  = echo > NUL
ILFLAGS  = /a /e

FILES  = CEXT.C CLEANUP.C CMTCMD.C TIMER.C TIMEBASE.C TEMPOMAP.C SEQWRITE.C\
	SEQEXTNS.C SEQREAD.C SEQ.C RECORD.C MPU.C MOXCMAIN.C MIDIFNS.C\
	SEQMREAD.C SEQMWRIT.C CMDLINE.C EXCLDESC.C MEM.C MOXC.C USERIO.C\
	MIDIFILE.C
OBJS  = CEXT.obj CLEANUP.obj CMTCMD.obj TIMER.obj TIMEBASE.obj TEMPOMAP.obj\
	SEQWRITE.obj SEQEXTNS.obj SEQREAD.obj SEQ.obj RECORD.obj MPU.obj\
	MOXCMAIN.obj MIDIFNS.obj SEQMREAD.obj SEQMWRIT.obj CMDLINE.obj\
	EXCLDESC.obj MEM.obj MOXC.obj USERIO.obj MIDIFILE.obj
SBRS  = CEXT.sbr CLEANUP.sbr CMTCMD.sbr TIMER.sbr TIMEBASE.sbr TEMPOMAP.sbr\
	SEQWRITE.sbr SEQEXTNS.sbr SEQREAD.sbr SEQ.sbr RECORD.sbr MPU.sbr\
	MOXCMAIN.sbr MIDIFNS.sbr SEQMREAD.sbr SEQMWRIT.sbr CMDLINE.sbr\
	EXCLDESC.sbr MEM.sbr MOXC.sbr USERIO.sbr MIDIFILE.sbr

all: $(PROJ).lib gswitch.h

.SUFFIXES:
.SUFFIXES:
.SUFFIXES: .sbr .obj .c

gswitch.h : switches.h
    copy switches.h gswitch.h

CEXT.obj : CEXT.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoCEXT.obj CEXT.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoCEXT.obj CEXT.C
<<
!ENDIF

CEXT.sbr : CEXT.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRCEXT.sbr CEXT.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRCEXT.sbr CEXT.C
<<
!ENDIF

CLEANUP.obj : CLEANUP.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoCLEANUP.obj CLEANUP.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoCLEANUP.obj CLEANUP.C
<<
!ENDIF

CLEANUP.sbr : CLEANUP.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRCLEANUP.sbr CLEANUP.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRCLEANUP.sbr CLEANUP.C
<<
!ENDIF

CMTCMD.obj : CMTCMD.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoCMTCMD.obj CMTCMD.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoCMTCMD.obj CMTCMD.C
<<
!ENDIF

CMTCMD.sbr : CMTCMD.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRCMTCMD.sbr CMTCMD.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRCMTCMD.sbr CMTCMD.C
<<
!ENDIF

TIMER.obj : TIMER.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoTIMER.obj TIMER.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoTIMER.obj TIMER.C
<<
!ENDIF

TIMER.sbr : TIMER.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRTIMER.sbr TIMER.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRTIMER.sbr TIMER.C
<<
!ENDIF

TIMEBASE.obj : TIMEBASE.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoTIMEBASE.obj TIMEBASE.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoTIMEBASE.obj TIMEBASE.C
<<
!ENDIF

TIMEBASE.sbr : TIMEBASE.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRTIMEBASE.sbr TIMEBASE.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRTIMEBASE.sbr TIMEBASE.C
<<
!ENDIF

TEMPOMAP.obj : TEMPOMAP.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoTEMPOMAP.obj TEMPOMAP.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoTEMPOMAP.obj TEMPOMAP.C
<<
!ENDIF

TEMPOMAP.sbr : TEMPOMAP.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRTEMPOMAP.sbr TEMPOMAP.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRTEMPOMAP.sbr TEMPOMAP.C
<<
!ENDIF

SEQWRITE.obj : SEQWRITE.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoSEQWRITE.obj SEQWRITE.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoSEQWRITE.obj SEQWRITE.C
<<
!ENDIF

SEQWRITE.sbr : SEQWRITE.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRSEQWRITE.sbr SEQWRITE.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRSEQWRITE.sbr SEQWRITE.C
<<
!ENDIF

SEQEXTNS.obj : SEQEXTNS.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoSEQEXTNS.obj SEQEXTNS.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoSEQEXTNS.obj SEQEXTNS.C
<<
!ENDIF

SEQEXTNS.sbr : SEQEXTNS.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRSEQEXTNS.sbr SEQEXTNS.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRSEQEXTNS.sbr SEQEXTNS.C
<<
!ENDIF

SEQREAD.obj : SEQREAD.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoSEQREAD.obj SEQREAD.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoSEQREAD.obj SEQREAD.C
<<
!ENDIF

SEQREAD.sbr : SEQREAD.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRSEQREAD.sbr SEQREAD.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRSEQREAD.sbr SEQREAD.C
<<
!ENDIF

SEQ.obj : SEQ.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoSEQ.obj SEQ.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoSEQ.obj SEQ.C
<<
!ENDIF

SEQ.sbr : SEQ.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRSEQ.sbr SEQ.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRSEQ.sbr SEQ.C
<<
!ENDIF

RECORD.obj : RECORD.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoRECORD.obj RECORD.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoRECORD.obj RECORD.C
<<
!ENDIF

RECORD.sbr : RECORD.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRRECORD.sbr RECORD.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRRECORD.sbr RECORD.C
<<
!ENDIF

MPU.obj : MPU.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoMPU.obj MPU.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoMPU.obj MPU.C
<<
!ENDIF

MPU.sbr : MPU.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRMPU.sbr MPU.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRMPU.sbr MPU.C
<<
!ENDIF

MOXCMAIN.obj : MOXCMAIN.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoMOXCMAIN.obj MOXCMAIN.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoMOXCMAIN.obj MOXCMAIN.C
<<
!ENDIF

MOXCMAIN.sbr : MOXCMAIN.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRMOXCMAIN.sbr MOXCMAIN.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRMOXCMAIN.sbr MOXCMAIN.C
<<
!ENDIF

MIDIFNS.obj : MIDIFNS.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoMIDIFNS.obj MIDIFNS.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoMIDIFNS.obj MIDIFNS.C
<<
!ENDIF

MIDIFNS.sbr : MIDIFNS.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRMIDIFNS.sbr MIDIFNS.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRMIDIFNS.sbr MIDIFNS.C
<<
!ENDIF

SEQMREAD.obj : SEQMREAD.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoSEQMREAD.obj SEQMREAD.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoSEQMREAD.obj SEQMREAD.C
<<
!ENDIF

SEQMREAD.sbr : SEQMREAD.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRSEQMREAD.sbr SEQMREAD.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRSEQMREAD.sbr SEQMREAD.C
<<
!ENDIF

SEQMWRIT.obj : SEQMWRIT.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoSEQMWRIT.obj SEQMWRIT.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoSEQMWRIT.obj SEQMWRIT.C
<<
!ENDIF

SEQMWRIT.sbr : SEQMWRIT.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRSEQMWRIT.sbr SEQMWRIT.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRSEQMWRIT.sbr SEQMWRIT.C
<<
!ENDIF

CMDLINE.obj : CMDLINE.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoCMDLINE.obj CMDLINE.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoCMDLINE.obj CMDLINE.C
<<
!ENDIF

CMDLINE.sbr : CMDLINE.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRCMDLINE.sbr CMDLINE.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRCMDLINE.sbr CMDLINE.C
<<
!ENDIF

EXCLDESC.obj : EXCLDESC.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoEXCLDESC.obj EXCLDESC.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoEXCLDESC.obj EXCLDESC.C
<<
!ENDIF

EXCLDESC.sbr : EXCLDESC.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FREXCLDESC.sbr EXCLDESC.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FREXCLDESC.sbr EXCLDESC.C
<<
!ENDIF

MEM.obj : MEM.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoMEM.obj MEM.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoMEM.obj MEM.C
<<
!ENDIF

MEM.sbr : MEM.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRMEM.sbr MEM.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRMEM.sbr MEM.C
<<
!ENDIF

MOXC.obj : MOXC.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoMOXC.obj MOXC.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoMOXC.obj MOXC.C
<<
!ENDIF

MOXC.sbr : MOXC.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRMOXC.sbr MOXC.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRMOXC.sbr MOXC.C
<<
!ENDIF

USERIO.obj : USERIO.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoUSERIO.obj USERIO.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoUSERIO.obj USERIO.C
<<
!ENDIF

USERIO.sbr : USERIO.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRUSERIO.sbr USERIO.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRUSERIO.sbr USERIO.C
<<
!ENDIF

MIDIFILE.obj : MIDIFILE.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /FoMIDIFILE.obj MIDIFILE.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /FoMIDIFILE.obj MIDIFILE.C
<<
!ENDIF

MIDIFILE.sbr : MIDIFILE.C
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FRMIDIFILE.sbr MIDIFILE.C
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FRMIDIFILE.sbr MIDIFILE.C
<<
!ENDIF


$(PROJ).bsc : $(SBRS)
	$(BSCMAKE) @<<
$(BRFLAGS) $(SBRS)
<<

$(PROJ).lib : $(OBJS)
!IF $(DEBUG)
	$(LRF) @<<$(PROJ).lrf
$(RT_OBJS: = +^
) $(OBJS: = +^
)
$@
$(MAPFILE_D)
$(LIBS: = +^
) +
$(LLIBS_G: = +^
) +
$(LLIBS_D: = +^
)
$(DEF_FILE) $(LFLAGS_G) $(LFLAGS_D);
<<
!ELSE
	$(LRF) @<<$(PROJ).lrf
$@
Y
$(RT_OBJS: = &^
+) +$(OBJS: = &^
+) ;
<<
!ENDIF
	del $@
	$(LIB) @$(PROJ).lrf


.c.sbr :
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_D) /FR$@ $<
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/Zs $(CFLAGS_G)
$(CFLAGS_R) /FR$@ $<
<<
!ENDIF

.c.obj :
!IF $(DEBUG)
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_D) /Fo$@ $<
<<
!ELSE
	@$(CC) @<<$(PROJ).rsp
/c $(CFLAGS_G)
$(CFLAGS_R) /Fo$@ $<
<<
!ENDIF
